## kooka 0.0+p24.04+vunstable+git20250926.0612

=== CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################

cmake_minimum_required(VERSION 3.16)

project(kooka)
set(VERSION "6.90.0")
message(STATUS "Configuring for Kooka/libkookascan version ${VERSION}")

set(QT_MIN_VERSION "6.7.0")
set(KF_MIN_VERSION "6.1.0")

# ECM setup (Extra Cmake Modules)
find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(FeatureSummary)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(CMakePackageConfigHelpers)
include(CheckFunctionExists)
include(GenerateExportHeader)
include(ECMInstallIcons)
include(ECMQtDeclareLoggingCategory)
include(KDEClangFormat)

# Options
option(INSTALL_BINARIES "Install the binaries and libraries, turn off for development in place" ON)

# Required Qt components to build this package
find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS Core Widgets)

# Rigourousness
add_definitions("-DQT_USE_QSTRINGBUILDER")
add_definitions("-DQT_NO_CAST_FROM_BYTEARRAY")
add_definitions("-DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT")
add_definitions("-DQT_NO_CAST_TO_ASCII")
add_definitions("-DQT_NO_URL_CAST_FROM_STRING")

# Permissiveness
remove_definitions("-DQT_NO_CAST_FROM_ASCII")
remove_definitions("-DQT_NO_KEYWORDS")

# Support for SANE, here because library and sanedump both need it
#
# Prefer pkg-config(1), because sane-config(1) was removed from Debian
# package sane-backends 1.0.25 in December 2016.  Assuming here that
# pkg-config(1) is available on any reasonable system.
find_package(PkgConfig)
if (PkgConfig_FOUND)
  pkg_check_modules(SANE sane-backends)
endif (PkgConfig_FOUND)

if (SANE_FOUND)
  set(SANE_CFLAGS "${SANE_CFLAGS}")
  string(REPLACE "-I" "" SANE_INCLUDES ${SANE_CFLAGS})
  set(SANE_LIBRARIES "${SANE_LDFLAGS}")
else (SANE_FOUND)
  # if pkg-config(1) did not find anything, then fall back to sane-config(1)
  message(STATUS "SANE not found via pkg-config(1), trying sane-config(1)")
  if (SANECONFIG_BIN)
    set(SANECONFIG_PROG ${SANECONFIG_BIN})
    message(STATUS "Specified sane-config(1), ${SANECONFIG_PROG}")
  else (SANECONFIG_BIN)
    find_program(SANECONFIG_PROG NAMES sane-config)
    message(STATUS "Found sane-config(1), ${SANECONFIG_PROG}")
  endif (SANECONFIG_BIN)

  if (SANECONFIG_PROG)
    set(SANE_FOUND true)
    execute_process(COMMAND ${SANECONFIG_PROG} --version OUTPUT_VARIABLE SANE_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${SANECONFIG_PROG} --cflags OUTPUT_VARIABLE SANE_INCLUDES OUTPUT_STRIP_TRAILING_WHITESPACE)
    execute_process(COMMAND ${SANECONFIG_PROG} --libs OUTPUT_VARIABLE SANE_LIBRARIES OUTPUT_STRIP_TRAILING_WHITESPACE)
    message(STATUS "Found SANE, version ${SANE_VERSION}")
endif (SANECONFIG_PROG)

endif (SANE_FOUND)

if (SANE_FOUND)
  set(HAVE_SANE true)
  message(STATUS "  SANE includes: ${SANE_INCLUDES}")
  message(STATUS "  SANE libraries: ${SANE_LIBRARIES}")
else (SANE_FOUND)
  message(SEND_ERROR "libkookascan needs SANE (http://www.sane-project.org) - install package or specify location of sane-config(1) with SANECONFIG_BIN")
endif (SANE_FOUND)

############### Common build flags ###############

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")

   # both gcc & clang support it since the same version
   if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 5.0.0)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wzero-as-null-pointer-constant" )
   endif()
endif()

############### Common install locations ###############

set(PICS_INSTALL_DIR ${KDE_INSTALL_DATADIR}/kooka/pics)

############### Common definitions ###############

add_definitions(-DKF5)

############### Now, we add the Kooka components ###############

add_subdirectory(libdialogutil)
add_subdirectory(libkookascan)
add_subdirectory(libfiletree)
add_subdirectory(app)
add_subdirectory(plugins)
add_subdirectory(doc)

add_subdirectory(tools EXCLUDE_FROM_ALL)

############### VCS revision number in vcsversion.h ###############

add_custom_target(vcsversion
  ALL
  COMMENT "Checking VCS version"
  VERBATIM
  COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/vcsversion.sh ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${VERSION}
)

########### Code formatting ###############

file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h *.c)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

# ########### documentation ###############
#
# if (HAVE_APIDOX)
#   add_custom_target(apidox
#     COMMENT "Generating API documentation in ${CMAKE_CURRENT_BINARY_DIR}..."
#     VERBATIM
#     COMMAND sh -c "${KDELIBS_SOURCE_DIR}/doc/api/doxygen.sh --no-modulename --recurse --doxdatadir=${KDELIBS_SOURCE_DIR}/doc/common ${CMAKE_CURRENT_SOURCE_DIR}; echo 'API documentation at file://${CMAKE_CURRENT_BINARY_DIR}/apidocs/index.html';")
# endif (HAVE_APIDOX)

############### Logging ###############

ecm_qt_install_logging_categories(
  EXPORT kookalogging
  FILE kooka.categories
  DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}")

############### Configuration information ###############

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== app/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


########### dependencies ###############

find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS PrintSupport)
find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS I18n Config TextWidgets KIO IconThemes XmlGui Crash)

############### Packages used by KDE ###############

include(CheckIncludeFile)
include(CheckFunctionExists)

############### Find the stuff we need ###############

check_function_exists(strerror HAVE_STRERROR)
if (HAVE_STRERROR)
  check_include_file(errno.h HAVE_ERRNO_H)		# pointless if no strerror()
endif (HAVE_STRERROR)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)

########### setup ###############

if (HAVE_ERRNO_H)
  add_definitions(-DHAVE_ERRNO_H)
endif (HAVE_ERRNO_H)
if (HAVE_STRERROR)
  add_definitions(-DHAVE_STRERROR)
endif (HAVE_STRERROR)
if (HAVE_SYS_STAT_H)
  add_definitions(-DHAVE_SYS_STAT_H)
endif (HAVE_SYS_STAT_H)
if (HAVE_SYS_TYPES_H)
  add_definitions(-DHAVE_SYS_TYPES_H)
endif (HAVE_SYS_TYPES_H)

include_directories(..)

########### logging ###############

ecm_qt_declare_logging_category(kooka_LOG_SRCS
  HEADER "kooka_logging.h"
  IDENTIFIER "KOOKA_LOG"
  CATEGORY_NAME "kooka"
  EXPORT kookalogging
  DESCRIPTION "application (Kooka)")

########### library shared with plugins ###############

set(kookacore_SRCS
  pluginmanager.cpp
  abstractplugin.cpp
  scangallery.cpp
  imgsaver.cpp			# -> imagesaver
  formatdialog.cpp
  galleryroot.cpp
  kookaprint.cpp
  imgprintdialog.cpp
  ${kooka_LOG_SRCS}
)
kconfig_add_kcfg_files(kookacore_SRCS kookasettings.kcfgc)

add_library(kookacore SHARED ${kookacore_SRCS})
generate_export_header(kookacore BASE_NAME kookacore)
set_target_properties(kookacore PROPERTIES VERSION ${VERSION} SOVERSION 6)
target_link_libraries(kookacore Qt6::Core Qt6::Gui Qt6::PrintSupport)
target_link_libraries(kookacore KF6::I18n KF6::KIOFileWidgets KF6::KIOWidgets KF6::IconThemes KF6::ConfigGui)
target_link_libraries(kookacore kookascan)
target_link_libraries(kookacore libfiletree)

if (INSTALL_BINARIES)
  install(TARGETS kookacore ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif (INSTALL_BINARIES)

########### executable ###############

# TODO: rename some of these files to match class name, some others are obsolete
set(kooka_SRCS
  main.cpp
  kooka.cpp			# -> kookamainwindow
  kookaview.cpp
  statusbarmanager.cpp
  kookapref.cpp			# -> kookaprefs
  prefspages.cpp
  kookascanparams.cpp
  imagetransform.cpp
  galleryhistory.cpp
  kookagallery.cpp
  thumbview.cpp
  kookaprint.cpp
  imgprintdialog.cpp
  scanpresetsdialog.cpp
  newscanpresetdialog.cpp
  ocrresedit.cpp
  ${kooka_LOG_SRCS}

  kooka.qrc
)

add_executable(kooka ${kooka_SRCS})
target_link_libraries(kooka
  Qt6::PrintSupport
  dialogutil
  kookacore
  kookadestination
  kookaocr
  KF6::KIOCore KF6::KIOFileWidgets KF6::KIOWidgets
  KF6::XmlGui
  KF6::Crash
  KF6::TextWidgets
)

include_directories(${CMAKE_CURRENT_BINARY_DIR}/..)
add_dependencies(kooka vcsversion)

########### install files ###############

if (INSTALL_BINARIES)
  install(TARGETS kooka ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif (INSTALL_BINARIES)
install(FILES kookasettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

# I18n for both kooka and libkookascan
ki18n_install(../po)

########### subdirectories ###############

add_subdirectory(pics)
add_subdirectory(desktop)

=== doc/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS DocTools)

kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kooka)

=== libdialogutil/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################

project(libdialogutil)

########### dependencies ###############

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS I18n Config KIO WidgetsAddons)

########### libdialogutil ###############

add_definitions(-DTRANSLATION_DOMAIN="libkookascan")

set(dialogutil_SRCS
  dialogbase.cpp
  dialogstatesaver.cpp
  dialogstatewatcher.cpp
  recentsaver.cpp
  imagefilter.cpp
  clickabletooltip.cpp
)
ecm_qt_declare_logging_category(dialogutil_SRCS
  HEADER "libdialogutil_logging.h"
  IDENTIFIER "LIBDIALOGUTIL_LOG"
  CATEGORY_NAME "libdialogutil"
  EXPORT kookalogging
  DESCRIPTION "libdialogutil (Kooka)")

set(dialogutil_HDRS
  dialogbase.h
  dialogstatesaver.h
  dialogstatewatcher.h
  recentsaver.h
  imagefilter.h
  ${CMAKE_CURRENT_BINARY_DIR}/libdialogutil_export.h
)

add_library(dialogutil SHARED ${dialogutil_SRCS})
generate_export_header(dialogutil BASE_NAME libdialogutil)
target_link_libraries(dialogutil
  Qt6::Core Qt6::Widgets
  KF6::I18n
  KF6::ConfigCore
  KF6::WidgetsAddons
  KF6::KIOCore KF6::KIOFileWidgets
)

set_target_properties(dialogutil PROPERTIES VERSION ${VERSION} SOVERSION 6)

########### package config ###############

set(DU "DialogUtil")
set(CONFIGDIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/${DU}")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/${DU}Config.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${DU}Config.cmake"
  INSTALL_DESTINATION ${CONFIGDIR})

########### installation ###############

install(TARGETS dialogutil ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES ${dialogutil_HDRS} DESTINATION ${KDE_INSTALL_INCLUDEDIR}/${DU})
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${DU}Config.cmake" DESTINATION ${CONFIGDIR} COMPONENT Devel)

=== libfiletree/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of libfiletree. originally part of KDE3.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################

project(libfiletree)

########### dependencies ###############

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS I18n KIO)

########### libfiletree ###############

set(libfiletree_SRCS
  filetreeview.cpp
  filetreebranch.cpp
  filetreeviewitem.cpp
)

ecm_qt_declare_logging_category(libfiletree_SRCS
  HEADER "libfiletree_logging.h"
  IDENTIFIER "LIBFILETREE_LOG"
  CATEGORY_NAME "libfiletree"
  EXPORT kookalogging
  DESCRIPTION "libfiletree (Kooka)")

add_library(libfiletree STATIC ${libfiletree_SRCS})
set_target_properties(libfiletree PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_link_libraries(libfiletree
  Qt6::Core Qt6::Widgets
  KF6::KIOCore
)

=== libkookascan/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of libkscan, a KDE scanning library.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################

project(libkookascan)

########### dependencies ###############

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS I18n Config ConfigWidgets IconThemes KIO)

# libpaper (at least in Gentoo Linux) provides neither a
# Find<package>.cmake nor a pkg-config file.
find_library(LIBPAPER_LIB NAMES "libpaper" "libpaper.so")
find_file(LIBPAPER_HDR "paper.h")
if (LIBPAPER_LIB AND LIBPAPER_HDR)
  message(STATUS "libpaper library: ${LIBPAPER_LIB}")
  message(STATUS "libpaper header: ${LIBPAPER_HDR}")
  set(HAVE_LIBPAPER 1)
else (LIBPAPER_LIB AND LIBPAPER_HDR)
  message(STATUS "libpaper library not found, using built-in list of paper sizes")
endif (LIBPAPER_LIB AND LIBPAPER_HDR)

############### Support for multi-page TIFF images ###############

include(FindTIFF)
if (TIFF_FOUND)
  message(STATUS "TIFF includes: ${TIFF_INCLUDE_DIR}")
  message(STATUS "TIFF libraries: ${TIFF_LIBRARIES}")
  set(HAVE_TIFF true)
else (TIFF_FOUND)
  message(STATUS "TIFF library not found, no multi-page image support")
endif (TIFF_FOUND)

########### subdirectories ###############

add_subdirectory(pics)
add_subdirectory(desktop)

########### setup ###############

if (HAVE_SANE)
  add_definitions(-DHAVE_SANE)
  add_definitions(-DSANE_VERSION=\"${SANE_VERSION}\")
  include_directories(${SANE_INCLUDES})
endif (HAVE_SANE)
if (HAVE_LIBPAPER)
  add_definitions(-DHAVE_LIBPAPER)
  get_filename_component(LIBPAPER_INCLUDES ${LIBPAPER_HDR} PATH)
  include_directories(${LIBPAPER_INCLUDES})
endif (HAVE_LIBPAPER)
if (HAVE_TIFF)
  add_definitions(-DHAVE_TIFF)
  include_directories(${TIFF_INCLUDE_DIR})
endif (HAVE_TIFF)

########### I18N ###############

add_definitions(-DTRANSLATION_DOMAIN="libkookascan")

########### library ###############

# TODO: rename some of these to match class name, others are obsolete
set(kookascan_SRCS
  scanglobal.cpp
  imageformat.cpp
  scanimage.cpp
  kscandevice.cpp
  scandevices.cpp
  kscancontrols.cpp
  kgammatable.cpp
  kscanoption.cpp
  kscanoptset.cpp
  gammadialog.cpp
  gammawidget.cpp
  scanparams.cpp
  scanparamspage.cpp
  deviceselector.cpp
  adddevicedialog.cpp
  imagecanvas.cpp
  previewer.cpp
  imgscaledialog.cpp
  sizeindicator.cpp
  scansizeselector.cpp
  autoselectbar.cpp
  autoselectdialog.cpp
  scanicons.cpp
)
kconfig_add_kcfg_files(kookascan_SRCS scansettings.kcfgc)
ecm_qt_declare_logging_category(kookascan_SRCS
  HEADER "libkookascan_logging.h"
  IDENTIFIER "LIBKOOKASCAN_LOG"
  CATEGORY_NAME "libkookascan"
  EXPORT kookalogging
  DESCRIPTION "libkookascan (Kooka)")

add_library(kookascan SHARED ${kookascan_SRCS})
generate_export_header(kookascan BASE_NAME kookascan)
target_link_libraries(kookascan
  dialogutil
  KF6::I18n
  KF6::ConfigCore KF6::ConfigGui KF6::ConfigWidgets
  KF6::KIOCore KF6::KIOWidgets
  KF6::IconThemes
)

if (HAVE_SANE)
  target_link_libraries(kookascan ${SANE_LIBRARIES})
endif (HAVE_SANE)
if (HAVE_LIBPAPER)
  target_link_libraries(kookascan ${LIBPAPER_LIB})
endif (HAVE_LIBPAPER)
if (HAVE_TIFF)
  target_link_libraries(kookascan ${TIFF_LIBRARIES})
endif (HAVE_TIFF)

set_target_properties(kookascan PROPERTIES VERSION ${VERSION} SOVERSION 6)

########### installation ###############

if (INSTALL_BINARIES)
  install(TARGETS kookascan ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif (INSTALL_BINARIES)
install(FILES scansettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

=== plugins/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


#########################################################################
#									#
#  Common definitions for plugins					#
#									#
#########################################################################

add_definitions("-DPLUGIN_EXPORT=__attribute__((visibility(\"default\")))")

#########################################################################
#									#
#  Subdirectories							#
#									#
#########################################################################

add_subdirectory(ocr)
add_subdirectory(destination)

=== tools/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################

project(kookatools)

########### dependencies ###############

find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS Core Gui)
find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS I18n CoreAddons)

########### sanedump ###############

set(sanedump_SRCS
  sanedump.c
)

if (HAVE_SANE)
  include_directories(${SANE_INCLUDES})
endif (HAVE_SANE)

add_executable(sanedump ${sanedump_SRCS})
if (HAVE_SANE)
  target_link_libraries(sanedump ${SANE_LIBRARIES})
endif (HAVE_SANE)

########### qimageioinfo ###############

set(qimageioinfo_SRCS
  qimageioinfo.cpp
)

add_executable(qimageioinfo ${qimageioinfo_SRCS})
target_link_libraries(qimageioinfo Qt6::Core Qt6::Gui)
target_link_libraries(qimageioinfo KF6::CoreAddons)

########### install files ###############

if (INSTALL_BINARIES)
  install(TARGETS sanedump ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
  install(TARGETS qimageioinfo ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif (INSTALL_BINARIES)

=== app/desktop/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


########### install files ###############

ecm_install_icons(ICONS 48-apps-kooka.png DESTINATION ${KDE_INSTALL_ICONDIR} THEME hicolor)
install(FILES org.kde.kooka.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== app/pics/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


########### install files ###############

set(kooka_PICS
  lockzoom.png
  newfromselect.png
  ocr.png
  ocr-select.png
  ocr-file.png
  photocopy.png
  preview.png
  scan.png
  scanadd.png
  scanselect.png
  thumbviewtile.png
  rotate-acw.png
  rotate-cw.png
  rotate-180.png
  autoselect.png
)

install(FILES ${kooka_PICS} DESTINATION ${PICS_INSTALL_DIR})

=== libkookascan/desktop/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of libkscan, a KDE scanning library.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


########### install files ###############

install(FILES scantypes.dat DESTINATION ${KDE_INSTALL_DATADIR}/libkookascan)

=== libkookascan/pics/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of libkscan, a KDE scanning library.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


########### install files ###############

set(libkookascan_PICS
  palette-color.png
  palette-gray.png
  palette-halftone.png
  palette-lineart.png
)

install(FILES ${libkookascan_PICS} DESTINATION ${KDE_INSTALL_DATADIR}/libkookascan/pics)

=== debian/changelog ===
kooka (0.0+p24.04+vunstable+git20250926.0612-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 26 Sep 2025 06:13:00 +0000

kooka (0.0-0neon) bionic; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Wed, 06 Mar 2019 15:09:07 +0000

=== debian/control ===
Source: kooka
Section: kde
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               kf6-extra-cmake-modules,
               kf6-kconfig-dev,
               kf6-kconfigwidgets-dev,
               kf6-kcrash-dev,
               kf6-kdoctools-dev,
               kf6-ki18n-dev,
               kf6-kiconthemes-dev,
               kf6-kio-dev,
               kf6-ktextwidgets-dev,
               kf6-kwidgetsaddons-dev,
               kf6-kxmlgui-dev,
               kf6-sonnet-dev,
               libpaper-dev,
               libsane-common,
               libsane-dev,
               pkg-kde-tools-neon,
               pkgconf,
               qt6-base-dev
Standards-Version: 4.6.2
Homepage: http://www.kde.org/
Vcs-Git: https://invent.kde.org/neon/neon-packaging/kooka.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/kooka
Maintainer: Neon CI <neon@kde.org>

Package: kooka
Architecture: any
Section: devel
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Scan & OCR Program
 Kooka is an intuitive, easy to use open source GNU/Linux scan
 program.

## kooka 0.0+p24.04+vunstable+git20251009.0612

=== debian/changelog ===
kooka (0.0+p24.04+vunstable+git20251009.0612-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 09 Oct 2025 06:12:11 +0000

## kooka 0.0+p24.04+vunstable+git20251111.0541

=== debian/changelog ===
kooka (0.0+p24.04+vunstable+git20251111.0541-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 11 Nov 2025 05:41:43 +0000

## kooka 0.0+p24.04+vunstable+git20251123.1903

=== debian/changelog ===
kooka (0.0+p24.04+vunstable+git20251123.1903-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 23 Nov 2025 19:04:03 +0000

## kooka 0.0+p24.04+vunstable+git20260201.0758

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 set(VERSION "6.90.0")
 message(STATUS "Configuring for Kooka/libkookascan version ${VERSION}")
 
-set(QT_MIN_VERSION "6.7.0")
+set(QT_MIN_VERSION "6.9.0")
 set(KF_MIN_VERSION "6.1.0")
 
 # ECM setup (Extra Cmake Modules)
@@ -40,6 +40,7 @@
 
 # Options
 option(INSTALL_BINARIES "Install the binaries and libraries, turn off for development in place" ON)
+option(BUILD_TOOLS "Build the testing tools and null destination plugin" OFF)
 
 # Required Qt components to build this package
 find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS Core Widgets)
@@ -126,7 +127,9 @@
 add_subdirectory(plugins)
 add_subdirectory(doc)
 
-add_subdirectory(tools EXCLUDE_FROM_ALL)
+if (BUILD_TOOLS)
+  add_subdirectory(tools)
+endif (BUILD_TOOLS)
 
 ############### VCS revision number in vcsversion.h ###############

=== app/CMakeLists.txt ===
--- 
+++ 
@@ -99,8 +99,6 @@
   galleryhistory.cpp
   kookagallery.cpp
   thumbview.cpp
-  kookaprint.cpp
-  imgprintdialog.cpp
   scanpresetsdialog.cpp
   newscanpresetdialog.cpp
   ocrresedit.cpp

=== libkookascan/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 ########### dependencies ###############
 
-find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS I18n Config ConfigWidgets IconThemes KIO)
+find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS I18n Config ConfigWidgets IconThemes KIO TextWidgets)
 
 # libpaper (at least in Gentoo Linux) provides neither a
 # Find<package>.cmake nor a pkg-config file.
@@ -31,7 +31,7 @@
 
 ############### Support for multi-page TIFF images ###############
 
-include(FindTIFF)
+find_package(TIFF)
 if (TIFF_FOUND)
   message(STATUS "TIFF includes: ${TIFF_INCLUDE_DIR}")
   message(STATUS "TIFF libraries: ${TIFF_LIBRARIES}")
@@ -93,6 +93,10 @@
   autoselectbar.cpp
   autoselectdialog.cpp
   scanicons.cpp
+  multiscanoptions.cpp
+  multiscandialog.cpp
+  continuescandialog.cpp
+  papersizes.cpp
 )
 kconfig_add_kcfg_files(kookascan_SRCS scansettings.kcfgc)
 ecm_qt_declare_logging_category(kookascan_SRCS
@@ -110,6 +114,7 @@
   KF6::ConfigCore KF6::ConfigGui KF6::ConfigWidgets
   KF6::KIOCore KF6::KIOWidgets
   KF6::IconThemes
+  KF6::TextWidgets
 )
 
 if (HAVE_SANE)

=== libkookascan/pics/CMakeLists.txt ===
--- 
+++ 
@@ -19,6 +19,10 @@
   palette-gray.png
   palette-halftone.png
   palette-lineart.png
+  page-rotation-none.png
+  page-rotation-90.png
+  page-rotation-180.png
+  page-rotation-270.png
 )
 
 install(FILES ${libkookascan_PICS} DESTINATION ${KDE_INSTALL_DATADIR}/libkookascan/pics)

=== plugins/destination/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


#########################################################################
#									#
#  Additional dependencies for scan destinations			#
#									#
#########################################################################

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS I18n CoreAddons WidgetsAddons)

find_package(KF6Purpose ${KF_MIN_VERSION})
set_package_properties(KF6Purpose PROPERTIES
  URL "https://invent.kde.org/frameworks/purpose"
  DESCRIPTION "A framework for services and actions integration"
  PURPOSE "Required for the Share Scan destination plugin"
  TYPE OPTIONAL
)

#########################################################################
#									#
#  Destination plugin base library					#
#									#
#########################################################################

ecm_qt_declare_logging_category(kookadestination_LOG_SRCS
  HEADER "destination_logging.h"
  IDENTIFIER "DESTINATION_LOG"
  CATEGORY_NAME "destination"
  EXPORT kookalogging
  DESCRIPTION "destination plugins (Kooka)")

set(kookadestination_SRCS
  abstractdestination.cpp
  ${kookadestination_LOG_SRCS}
)

add_definitions(-DLIBEXEC_DIR=\"${CMAKE_INSTALL_FULL_LIBEXECDIR}\")
add_library(kookadestination SHARED ${kookadestination_SRCS})
set_target_properties(kookadestination PROPERTIES VERSION ${VERSION} SOVERSION 6)
target_link_libraries(kookadestination Qt6::Core Qt6::Widgets)
target_link_libraries(kookadestination KF6::I18n KF6::WidgetsAddons)
target_link_libraries(kookadestination kookascan kookacore)

if (INSTALL_BINARIES)
  install(TARGETS kookadestination ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif (INSTALL_BINARIES)

#########################################################################
#									#
#  Subdirectories							#
#									#
#########################################################################

add_subdirectory(gallery)
add_subdirectory(application)
add_subdirectory(clipboard)
add_subdirectory(print)
add_subdirectory(save)
add_subdirectory(multipage)

if (KF6Purpose_FOUND)
  add_subdirectory(share)
endif (KF6Purpose_FOUND)

if (BUILD_TOOLS)
  add_subdirectory(null)
endif (BUILD_TOOLS)

=== plugins/destination/multipage/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


#########################################################################
#									#
#  Destination plugin for generating multi-page output			#
#									#
#########################################################################

set(destinationmultipage_SRCS
  destinationmultipage.cpp
  multipageoptionsdialog.cpp
  abstractmultipagewriter.cpp
  multipagepdfwriter.cpp
  ${kookadestination_LOG_SRCS}
)

find_program(TIFFCP_COMMAND "tiffcp")
if (TIFFCP_COMMAND)
  add_definitions("-DHAVE_TIFF")
  set(destinationmultipage_SRCS ${destinationmultipage_SRCS} multipagetiffwriter.cpp)
  message(STATUS "Found tiffcp(1) command: ${TIFFCP_COMMAND}")
else ()
  message(WARNING "tiffcp(1) command not found, multipage TIFF output not available")
endif ()

kcoreaddons_add_plugin(destinationmultipage SOURCES ${destinationmultipage_SRCS} INSTALL_NAMESPACE "kooka_destination")

target_link_libraries(destinationmultipage Qt${Q}::Gui)
target_link_libraries(destinationmultipage kookadestination kookascan)

=== plugins/destination/null/CMakeLists.txt ===
##########################################################################
##									##
##  This CMake file is part of Kooka, a KDE scanning/OCR application.	##
##									##
##  This file may be distributed and/or modified under the terms of	##
##  the GNU General Public License version 2, as published by the	##
##  Free Software Foundation and appearing in the file COPYING		##
##  included in the packaging of this file.				##
##									##
##  Author:  Jonathan Marten <jjm AT keelhaul DOT me DOT uk>		##
##									##
##########################################################################


#########################################################################
#									#
#  Destination plugin that simply discards the scanned image		#
#									#
#########################################################################

set(destinationnull_SRCS
  destinationnull.cpp
  ${kookadestination_LOG_SRCS}
)

kcoreaddons_add_plugin(destinationnull SOURCES ${destinationnull_SRCS} INSTALL_NAMESPACE "kooka_destination")

target_link_libraries(destinationnull Qt${Q}::Gui)
target_link_libraries(destinationnull kookadestination kookascan)

=== debian/changelog ===
kooka (0.0+p24.04+vunstable+git20260201.0758-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 01 Feb 2026 07:58:56 +0000

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
                kf6-ktextwidgets-dev,
                kf6-kwidgetsaddons-dev,
                kf6-kxmlgui-dev,
+               kf6-purpose-dev,
                kf6-sonnet-dev,
                libpaper-dev,
                libsane-common,

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_CXX_STANDARD=20
